Index: data/trunk/models/ships/powerdrifter.mtl
===================================================================
--- data/trunk/models/ships/powerdrifter.mtl	(revision 3631)
+++ data/trunk/models/ships/powerdrifter.mtl	(revision 3631)
@@ -0,0 +1,82 @@
+#  ==========================================================================
+#  Wavefront Material file
+#  Exported by Red-i Production's "Riptide"
+#        (a Cinema 4D v7 & v8 Plugin)
+#  
+#  Red-i Productions
+#  http://www.skinprops.com
+#  spanki@cablenet-va.com
+#  
+#  ==========================================================================
+
+newmtl default
+Ns 0.000000
+d 1.000000
+illum 2
+Ka 0.000000 0.000000 0.000000
+Kd 0.000000 0.000000 0.000000
+Ks 0.000000 0.000000 0.000000
+
+newmtl Mat.6
+Ns 50.781250
+d 1.000000
+illum 2
+Ka 0.000000 0.000000 0.000000
+Kd 0.800000 0.800000 0.800000
+Ks 0.000000 0.000000 0.000000
+map_Kd hull38L.jpg
+map_Bump hull38L.tga
+
+newmtl Mat.7
+Ns 50.781250
+d 1.000000
+illum 2
+Ka 0.000000 0.000000 0.000000
+Kd 0.800000 0.800000 0.800000
+Ks 0.000000 0.000000 0.000000
+map_Kd hull29L.jpg
+map_Bump hull29L.jpg
+
+newmtl Mat.8
+Ns 50.781250
+d 1.000000
+illum 2
+Ka 0.000000 0.000000 0.000000
+Kd 1.000000 1.000000 1.000000
+Ks 0.000000 0.000000 0.000000
+
+newmtl Mat.5
+Ns 50.781250
+d 1.000000
+illum 2
+Ka 0.000000 0.000000 0.000000
+Kd 0.000000 0.000000 0.072157
+Ks 0.000000 0.000000 0.000000
+
+newmtl Mat
+Ns 50.781250
+d 1.000000
+illum 2
+Ka 0.000000 0.000000 0.000000
+Kd 0.350000 0.350000 0.350000
+Ks 0.000000 0.000000 0.000000
+
+newmtl Mat.1
+Ns 50.781250
+d 1.000000
+illum 2
+Ka 0.000000 0.000000 0.000000
+Kd 0.800000 0.800000 0.800000
+Ks 0.000000 0.000000 0.000000
+map_Kd hull46L.jpg
+map_Bump hull46L.jpg
+
+newmtl Mat.2
+Ns 50.781250
+d 1.000000
+illum 2
+Ka 0.000000 0.000000 0.000000
+Kd 0.800000 0.800000 0.800000
+Ks 0.000000 0.000000 0.000000
+map_Kd hull38L.jpg
+map_Bump hull38L.jpg
Index: data/trunk/models/ships/warcruiser.mtl
===================================================================
--- data/trunk/models/ships/warcruiser.mtl	(revision 3631)
+++ data/trunk/models/ships/warcruiser.mtl	(revision 3631)
@@ -0,0 +1,72 @@
+#  ==========================================================================
+#  Wavefront Material file
+#  Exported by Red-i Production's "Riptide"
+#        (a Cinema 4D v7 & v8 Plugin)
+#  
+#  Red-i Productions
+#  http://www.skinprops.com
+#  spanki@cablenet-va.com
+#  
+#  ==========================================================================
+
+newmtl Mat.8
+Ns 50.781250
+d 1.000000
+illum 2
+Ka 0.000000 0.000000 0.000000
+Kd 1.000000 1.000000 1.000000
+Ks 0.000000 0.000000 0.000000
+
+newmtl Mat
+Ns 50.781250
+d 1.000000
+illum 2
+Ka 0.000000 0.000000 0.000000
+Kd 0.350000 0.350000 0.350000
+Ks 0.000000 0.000000 0.000000
+
+newmtl Mat.1
+Ns 50.781250
+d 1.000000
+illum 2
+Ka 0.000000 0.000000 0.000000
+Kd 0.800000 0.800000 0.800000
+Ks 0.000000 0.000000 0.000000
+map_Kd hull46L.jpg
+map_Bump hull46L.jpg
+
+newmtl Mat.2
+Ns 50.781250
+d 1.000000
+illum 2
+Ka 0.000000 0.000000 0.000000
+Kd 0.800000 0.800000 0.800000
+Ks 0.000000 0.000000 0.000000
+map_Kd hull38L.jpg
+map_Bump hull38L.jpg
+
+newmtl Mat.3
+Ns 50.781250
+d 1.000000
+illum 2
+Ka 0.000000 0.000000 0.000000
+Kd 0.800000 0.800000 0.800000
+Ks 0.000000 0.000000 0.000000
+map_Kd hull29L.jpg
+map_Bump hull29L.jpg
+
+newmtl Mat.5
+Ns 50.781250
+d 1.000000
+illum 2
+Ka 0.000000 0.000000 0.000000
+Kd 0.000000 0.000000 0.072157
+Ks 0.000000 0.000000 0.000000
+
+newmtl Mat.4
+Ns 50.781250
+d 1.000000
+illum 2
+Ka 0.000000 0.000000 0.000000
+Kd 1.000000 1.000000 1.000000
+Ks 0.000000 0.000000 0.000000
Index: data/trunk/worlds/AviPlay.oxw
===================================================================
--- data/trunk/worlds/AviPlay.oxw	(revision 3631)
+++ data/trunk/worlds/AviPlay.oxw	(revision 3631)
@@ -0,0 +1,182 @@
+<WorldDataFile>
+  <name>MeteroidCinema</name>
+  <menu-item-image>pictures/menu/se_straight_512x128.png</menu-item-image>
+  <screenshoot>pictures/menu/ss_straight_512x512.png</screenshoot>
+
+  <LoadScreen>
+    <BackgroundImage>pictures/load_screen.jpg</BackgroundImage>
+
+    <ElementCount>16</ElementCount>
+    <BackgroundPS>0,0,1.0,1</BackgroundPS>
+    <BarPS>.65,.87,.3,.05</BarPS>
+    <BarImage>pictures/load_screen_bar.png</BarImage>
+  </LoadScreen>
+  <WorldEntities>
+
+    <Hover>
+      <name>Player</name>
+<abs-coor>342.19, 169.36, 37.74</abs-coor>
+    </Hover>
+
+    <SpaceShip>
+      <name>Player2</name>
+      <model>models/ships/reap_#.obj</model>
+      <abs-coor>342.19, 169.36, 37.74</abs-coor>
+    </SpaceShip>
+
+    <SpaceShip>
+      <name>Player3</name>
+      <model>models/ships/mantawing.obj</model>
+      <abs-coor>338.53, 172.09, 7.04</abs-coor>
+    </SpaceShip>
+
+        <SpaceShip>
+      <name>Player4</name>
+      <model>models/ships/warcruiser.obj</model>
+      <abs-coor>331.19, 171.36, 49.74</abs-coor>
+    </SpaceShip>
+
+    <SpaceShip>
+      <name>Player5</name>
+      <model>models/ships/powerdrifter.obj</model>
+      <abs-coor>331.19, 171.36, 25.74</abs-coor>
+      <abs-dir>1.5,0,1,0</abs-dir>
+    </SpaceShip>
+
+
+    <SpaceShip>
+      <name>Player6</name>
+      <model>models/ships/gobblin.obj</model>
+      <abs-coor>311.53, 181.09, 12.04</abs-coor>
+    </SpaceShip>
+
+        <SpaceShip>
+      <name>Player7</name>
+      <model>models/ships/fighter.obj</model>
+      <abs-coor>311.53, 181.09, 39.04</abs-coor>
+    </SpaceShip>
+
+    <Hover>
+      <name>Player6</name>
+      <abs-coor>311.53, 181.09, 66.04</abs-coor>
+    </Hover>
+
+
+
+        <SpaceShip>
+      <name>Player7</name>
+      <model>models/ships/reap_#.obj</model>
+      <abs-coor>332.19, 200.36, 34.74</abs-coor>
+    </SpaceShip>
+
+    <SpaceShip>
+      <name>Player8</name>
+      <model>models/ships/mantawing.obj</model>
+      <abs-coor>328.53, 200.09, 17.04</abs-coor>
+    </SpaceShip>
+
+        <SpaceShip>
+      <name>Player9</name>
+      <model>models/ships/warcruiser.obj</model>
+      <abs-coor>321.19, 200.36, 39.74</abs-coor>
+    </SpaceShip>
+
+    <SpaceShip>
+      <name>Player10</name>
+      <model>models/ships/powerdrifter.obj</model>
+      <abs-coor>321.19, 200.36, 28.74</abs-coor>
+      <abs-dir>1.5,0,1,0</abs-dir>
+    </SpaceShip>
+
+
+    <SpaceShip>
+      <name>Player11</name>
+      <model>models/ships/gobblin.obj</model>
+      <abs-coor>301.53, 210.09, 5.04</abs-coor>
+    </SpaceShip>
+
+        <SpaceShip>
+      <name>Player12</name>
+      <model>models/ships/fighter.obj</model>
+      <abs-coor>301.53, 210.09, 33.04</abs-coor>
+    </SpaceShip>
+
+    <Hover>
+      <name>Player13</name>
+      <abs-coor>301.53, 210.09, 70.04</abs-coor>
+    </Hover>
+
+
+            <SpaceShip>
+      <name>Player14</name>
+      <model>models/ships/reap_#.obj</model>
+      <abs-coor>332.19, 190.36, 34.74</abs-coor>
+    </SpaceShip>
+
+    <SpaceShip>
+      <name>Player15</name>
+      <model>models/ships/mantawing.obj</model>
+      <abs-coor>328.53, 190.09, 17.04</abs-coor>
+    </SpaceShip>
+
+        <SpaceShip>
+      <name>Player16</name>
+      <model>models/ships/warcruiser.obj</model>
+      <abs-coor>321.19, 190.36, 39.74</abs-coor>
+    </SpaceShip>
+
+    <SpaceShip>
+      <name>Player17</name>
+      <model>models/ships/powerdrifter.obj</model>
+      <abs-coor>321.19, 190.36, 28.74</abs-coor>
+      <abs-dir>1.5,0,1,0</abs-dir>
+    </SpaceShip>
+
+
+    <SpaceShip>
+      <name>Player18</name>
+      <model>models/ships/gobblin.obj</model>
+      <abs-coor>301.53, 190.09, 5.04</abs-coor>
+    </SpaceShip>
+
+        <SpaceShip>
+      <name>Player19</name>
+      <model>models/ships/fighter.obj</model>
+      <abs-coor>301.53, 190.09, 33.04</abs-coor>
+    </SpaceShip>
+
+<SkyBox>
+     <name>Sky</name>
+     <Materialset>pictures/sky/simple_space</Materialset>
+     <Size>10000</Size>
+    </SkyBox>
+
+
+    <Terrain>
+      <name>Meteroit</name>
+      <abs-coor>300,50,0</abs-coor>
+      <model>models/environments/meteorit.obj, 2.5</model>
+    </Terrain>
+
+    <MovieEntity>
+      <abs-coor>402.67, 188.16, 36.99</abs-coor>
+      <name>media/crash.mpg</name>
+      <axis>90</axis>
+      <size>72,40.5</size>
+    </MovieEntity>
+
+  </WorldEntities>
+    <LightManager>
+    <Lights>
+      <Light>
+       <diffuse-color>1,1,1</diffuse-color>
+       <abs-coor>100,100,50</abs-coor>
+      </Light>
+    <Light>
+       <diffuse-color>1,1,1</diffuse-color>
+       <abs-coor>100,200,50</abs-coor>
+      </Light>
+      <ambient-color>1,1,1</ambient-color>
+    </Lights>
+  </LightManager>
+</WorldDataFile>
Index: data/trunk/worlds/DefaultCampaign.oxc
===================================================================
--- data/trunk/worlds/DefaultCampaign.oxc	(revision 3630)
+++ data/trunk/worlds/DefaultCampaign.oxc	(revision 3631)
@@ -4,27 +4,37 @@
   <description>The one and only default debug campaign</description>
   <WorldList>
+
     <SimpleGameMenu>
       <identifier>0</identifier>
       <name>GameMenu</name>
-      <nextid>1</nextid>
       <path>worlds/SimpleMenu.oxw</path>
     </SimpleGameMenu>
-
     <SinglePlayerWorld>
       <identifier>1</identifier>
       <nextid>2</nextid>
       <path>worlds/Straight.oxw</path>
+      <menu-entry>1</menu-entry>
     </SinglePlayerWorld>
+
+
+<!--
+    <MovieLoader>
+      <identifier>1</identifier>
+      <nextid>2</nextid>
+      <name>media/orxonox-logo.avi</name>
+      <menu-entry>1</menu-entry>
+    </MovieLoader>
 
     <SinglePlayerWorld>
       <identifier>2</identifier>
       <nextid>3</nextid>
-      <path>worlds/christmas.oxw</path>
+      <path>worlds/AviPlay.oxw</path>
     </SinglePlayerWorld>
-
+-->
     <SinglePlayerWorld>
       <identifier>3</identifier>
       <nextid>4</nextid>
-      <path>worlds/DefaultWorld.oxw</path>
+      <path>worlds/christmas.oxw</path>
+      <menu-entry>1</menu-entry>
     </SinglePlayerWorld>
 
@@ -32,11 +42,20 @@
       <identifier>4</identifier>
       <nextid>5</nextid>
-      <path>worlds/vulcania.oxw</path>
+      <path>worlds/DefaultWorld.oxw</path>
+      <menu-entry>1</menu-entry>
     </SinglePlayerWorld>
 
     <SinglePlayerWorld>
       <identifier>5</identifier>
+      <nextid>6</nextid>
+      <path>worlds/vulcania.oxw</path>
+      <menu-entry>1</menu-entry>
+    </SinglePlayerWorld>
+
+    <SinglePlayerWorld>
+      <identifier>6</identifier>
       <nextid>999</nextid>
       <path>worlds/World2.oxw</path>
+      <menu-entry>1</menu-entry>
     </SinglePlayerWorld>
 
Index: data/trunk/worlds/Straight.oxw
===================================================================
--- data/trunk/worlds/Straight.oxw	(revision 3630)
+++ data/trunk/worlds/Straight.oxw	(revision 3631)
@@ -1,5 +1,4 @@
 <WorldDataFile>
   <name>Straight</name>
-  <menu-entry>1</menu-entry>
   <menu-item-image>pictures/menu/se_straight_512x128.png</menu-item-image>
   <screenshoot>pictures/menu/ss_straight_512x512.png</screenshoot>
Index: data/trunk/worlds/World2.oxw
===================================================================
--- data/trunk/worlds/World2.oxw	(revision 3630)
+++ data/trunk/worlds/World2.oxw	(revision 3631)
@@ -1,5 +1,4 @@
 <WorldDataFile>
   <name>Darkness</name>
-  <menu-entry>1</menu-entry>
   <menu-item-image>pictures/menu/se_default_512x128.png</menu-item-image>
   <screenshoot>pictures/menu/ss_default_512x512.png</screenshoot>
Index: data/trunk/worlds/christmas.oxw
===================================================================
--- data/trunk/worlds/christmas.oxw	(revision 3630)
+++ data/trunk/worlds/christmas.oxw	(revision 3631)
@@ -2,5 +2,4 @@
   <name>Christmas</name>
   <description>This is the Demo Level for the christmas eve level.</description>
-  <menu-entry>1</menu-entry>
   <menu-item-image>pictures/menu/se_christmas_512x128.png</menu-item-image>
   <screenshoot>pictures/menu/ss_christmas_512x512.png</screenshoot>
Index: data/trunk/worlds/vulcania.oxw
===================================================================
--- data/trunk/worlds/vulcania.oxw	(revision 3630)
+++ data/trunk/worlds/vulcania.oxw	(revision 3631)
@@ -1,5 +1,4 @@
 <WorldDataFile>
   <name>Vulcania</name>
-  <menu-entry>1</menu-entry>
   <menu-item-image>pictures/menu/se_vulcano_512x128.png</menu-item-image>
   <screenshoot>pictures/menu/ss_vulcano_512x512.png</screenshoot>