Index: data/branches/avi_play/worlds/AviPlay.oxw
===================================================================
--- data/branches/avi_play/worlds/AviPlay.oxw	(revision 3643)
+++ 	(revision )
@@ -1,182 +1,0 @@
-<WorldDataFile>
-  <name>MeteroidCinema</name>
-  <menu-item-image>pictures/menu/se_straight_512x128.png</menu-item-image>
-  <screenshoot>pictures/menu/ss_straight_512x512.png</screenshoot>
-
-  <LoadScreen>
-    <BackgroundImage>pictures/load_screen.jpg</BackgroundImage>
-
-    <ElementCount>16</ElementCount>
-    <BackgroundPS>0,0,1.0,1</BackgroundPS>
-    <BarPS>.65,.87,.3,.05</BarPS>
-    <BarImage>pictures/load_screen_bar.png</BarImage>
-  </LoadScreen>
-  <WorldEntities>
-
-    <Hover>
-      <name>Player</name>
-<abs-coor>342.19, 169.36, 37.74</abs-coor>
-    </Hover>
-
-    <SpaceShip>
-      <name>Player2</name>
-      <model>models/ships/reap_#.obj</model>
-      <abs-coor>342.19, 169.36, 37.74</abs-coor>
-    </SpaceShip>
-
-    <SpaceShip>
-      <name>Player3</name>
-      <model>models/ships/mantawing.obj</model>
-      <abs-coor>338.53, 172.09, 7.04</abs-coor>
-    </SpaceShip>
-
-        <SpaceShip>
-      <name>Player4</name>
-      <model>models/ships/warcruiser.obj</model>
-      <abs-coor>331.19, 171.36, 49.74</abs-coor>
-    </SpaceShip>
-
-    <SpaceShip>
-      <name>Player5</name>
-      <model>models/ships/powerdrifter.obj</model>
-      <abs-coor>331.19, 171.36, 25.74</abs-coor>
-      <abs-dir>1.5,0,1,0</abs-dir>
-    </SpaceShip>
-
-
-    <SpaceShip>
-      <name>Player6</name>
-      <model>models/ships/gobblin.obj</model>
-      <abs-coor>311.53, 181.09, 12.04</abs-coor>
-    </SpaceShip>
-
-        <SpaceShip>
-      <name>Player7</name>
-      <model>models/ships/fighter.obj</model>
-      <abs-coor>311.53, 181.09, 39.04</abs-coor>
-    </SpaceShip>
-
-    <Hover>
-      <name>Player6</name>
-      <abs-coor>311.53, 181.09, 66.04</abs-coor>
-    </Hover>
-
-
-
-        <SpaceShip>
-      <name>Player7</name>
-      <model>models/ships/reap_#.obj</model>
-      <abs-coor>332.19, 200.36, 34.74</abs-coor>
-    </SpaceShip>
-
-    <SpaceShip>
-      <name>Player8</name>
-      <model>models/ships/mantawing.obj</model>
-      <abs-coor>328.53, 200.09, 17.04</abs-coor>
-    </SpaceShip>
-
-        <SpaceShip>
-      <name>Player9</name>
-      <model>models/ships/warcruiser.obj</model>
-      <abs-coor>321.19, 200.36, 39.74</abs-coor>
-    </SpaceShip>
-
-    <SpaceShip>
-      <name>Player10</name>
-      <model>models/ships/powerdrifter.obj</model>
-      <abs-coor>321.19, 200.36, 28.74</abs-coor>
-      <abs-dir>1.5,0,1,0</abs-dir>
-    </SpaceShip>
-
-
-    <SpaceShip>
-      <name>Player11</name>
-      <model>models/ships/gobblin.obj</model>
-      <abs-coor>301.53, 210.09, 5.04</abs-coor>
-    </SpaceShip>
-
-        <SpaceShip>
-      <name>Player12</name>
-      <model>models/ships/fighter.obj</model>
-      <abs-coor>301.53, 210.09, 33.04</abs-coor>
-    </SpaceShip>
-
-    <Hover>
-      <name>Player13</name>
-      <abs-coor>301.53, 210.09, 70.04</abs-coor>
-    </Hover>
-
-
-            <SpaceShip>
-      <name>Player14</name>
-      <model>models/ships/reap_#.obj</model>
-      <abs-coor>332.19, 190.36, 34.74</abs-coor>
-    </SpaceShip>
-
-    <SpaceShip>
-      <name>Player15</name>
-      <model>models/ships/mantawing.obj</model>
-      <abs-coor>328.53, 190.09, 17.04</abs-coor>
-    </SpaceShip>
-
-        <SpaceShip>
-      <name>Player16</name>
-      <model>models/ships/warcruiser.obj</model>
-      <abs-coor>321.19, 190.36, 39.74</abs-coor>
-    </SpaceShip>
-
-    <SpaceShip>
-      <name>Player17</name>
-      <model>models/ships/powerdrifter.obj</model>
-      <abs-coor>321.19, 190.36, 28.74</abs-coor>
-      <abs-dir>1.5,0,1,0</abs-dir>
-    </SpaceShip>
-
-
-    <SpaceShip>
-      <name>Player18</name>
-      <model>models/ships/gobblin.obj</model>
-      <abs-coor>301.53, 190.09, 5.04</abs-coor>
-    </SpaceShip>
-
-        <SpaceShip>
-      <name>Player19</name>
-      <model>models/ships/fighter.obj</model>
-      <abs-coor>301.53, 190.09, 33.04</abs-coor>
-    </SpaceShip>
-
-<SkyBox>
-     <name>Sky</name>
-     <Materialset>pictures/sky/simple_space</Materialset>
-     <Size>10000</Size>
-    </SkyBox>
-
-
-    <Terrain>
-      <name>Meteroit</name>
-      <abs-coor>300,50,0</abs-coor>
-      <model>models/environments/meteorit.obj, 2.5</model>
-    </Terrain>
-
-    <MovieEntity>
-      <abs-coor>402.67, 188.16, 36.99</abs-coor>
-      <name>media/crash.mpg</name>
-      <axis>90</axis>
-      <size>72,40.5</size>
-    </MovieEntity>
-
-  </WorldEntities>
-    <LightManager>
-    <Lights>
-      <Light>
-       <diffuse-color>1,1,1</diffuse-color>
-       <abs-coor>100,100,50</abs-coor>
-      </Light>
-    <Light>
-       <diffuse-color>1,1,1</diffuse-color>
-       <abs-coor>100,200,50</abs-coor>
-      </Light>
-      <ambient-color>1,1,1</ambient-color>
-    </Lights>
-  </LightManager>
-</WorldDataFile>
Index: data/branches/avi_play/worlds/DefaultCampaign.oxc
===================================================================
--- data/branches/avi_play/worlds/DefaultCampaign.oxc	(revision 3643)
+++ data/branches/avi_play/worlds/DefaultCampaign.oxc	(revision 3648)
@@ -11,5 +11,5 @@
       <nextid>1</nextid>
     </SimpleGameMenu>
-
+<!--
     <SinglePlayerWorld>
       <identifier>1</identifier>
@@ -18,11 +18,12 @@
       <menu-entry>1</menu-entry>
     </SinglePlayerWorld>
+-->
 
 
-<!--
     <MovieLoader>
       <identifier>1</identifier>
       <nextid>2</nextid>
-      <name>media/orxonox-logo.avi</name>
+      <name>Meteroid Cinema</name>
+      <movie>media/orxonox-logo.avi</movie>
       <menu-entry>1</menu-entry>
     </MovieLoader>
@@ -31,7 +32,7 @@
       <identifier>2</identifier>
       <nextid>3</nextid>
-      <path>worlds/AviPlay.oxw</path>
+      <path>worlds/MeteroidCinema.oxw</path>
     </SinglePlayerWorld>
--->
+
     <SinglePlayerWorld>
       <identifier>3</identifier>
Index: data/branches/avi_play/worlds/MeteroidCinema.oxw
===================================================================
--- data/branches/avi_play/worlds/MeteroidCinema.oxw	(revision 3648)
+++ data/branches/avi_play/worlds/MeteroidCinema.oxw	(revision 3648)
@@ -0,0 +1,218 @@
+<WorldDataFile>
+  <name>MeteroidCinema</name>
+  <menu-item-image>pictures/menu/se_straight_512x128.png</menu-item-image>
+  <screenshoot>pictures/menu/ss_straight_512x512.png</screenshoot>
+
+  <LoadScreen>
+    <BackgroundImage>pictures/load_screen.jpg</BackgroundImage>
+
+    <ElementCount>16</ElementCount>
+    <BackgroundPS>0,0,1.0,1</BackgroundPS>
+    <BarPS>.65,.87,.3,.05</BarPS>
+    <BarImage>pictures/load_screen_bar.png</BarImage>
+  </LoadScreen>
+  <WorldEntities>
+
+
+    <ModelParticles>
+      <name>VulcanStoneSystem</name>
+      <model>models/comet.obj</model>
+      <life-span>6000.0</life-span>
+      <radius>0,5,3</radius>
+      <mass>0,.1,0</mass>
+      <precache>5</precache>
+      <emitters>
+        <BoxEmitter>
+          <name>VulcanStoneEmitter</name>
+          <emission-velocity>5,5</emission-velocity>
+          <rate>20</rate>
+          <size>2000, 100, 2000</size>;
+          <abs-coor>342.19, 469.36, 37.74</abs-coor>
+          <spread>1,.5</spread>
+        </BoxEmitter>
+      </emitters>
+    </ModelParticles>
+
+    <Hover>
+      <name>Player</name>
+<abs-coor>342.19, 169.36, 37.74</abs-coor>
+    </Hover>
+
+    <SpaceShip>
+      <name>Player2</name>
+      <model>models/ships/reap_#.obj</model>
+      <abs-coor>342.19, 169.36, 37.74</abs-coor>
+    </SpaceShip>
+
+    <SpaceShip>
+      <name>Player3</name>
+      <model>models/ships/mantawing.obj</model>
+      <abs-coor>338.53, 172.09, 7.04</abs-coor>
+    </SpaceShip>
+
+        <SpaceShip>
+      <name>Player4</name>
+      <model>models/ships/warcruiser.obj</model>
+      <abs-coor>331.19, 171.36, 49.74</abs-coor>
+    </SpaceShip>
+
+    <SpaceShip>
+      <name>Player5</name>
+      <model>models/ships/powerdrifter.obj</model>
+      <abs-coor>331.19, 171.36, 25.74</abs-coor>
+      <abs-dir>1.5,0,1,0</abs-dir>
+    </SpaceShip>
+
+
+    <SpaceShip>
+      <name>Player6</name>
+      <model>models/ships/gobblin.obj</model>
+      <abs-coor>311.53, 181.09, 12.04</abs-coor>
+    </SpaceShip>
+
+        <SpaceShip>
+      <name>Player7</name>
+      <model>models/ships/fighter.obj</model>
+      <abs-coor>311.53, 181.09, 39.04</abs-coor>
+    </SpaceShip>
+
+    <Hover>
+      <name>Player6</name>
+      <abs-coor>311.53, 181.09, 66.04</abs-coor>
+    </Hover>
+
+
+
+        <SpaceShip>
+      <name>Player7</name>
+      <model>models/ships/reap_#.obj</model>
+      <abs-coor>332.19, 200.36, 34.74</abs-coor>
+    </SpaceShip>
+
+    <SpaceShip>
+      <name>Player8</name>
+      <model>models/ships/mantawing.obj</model>
+      <abs-coor>328.53, 200.09, 17.04</abs-coor>
+    </SpaceShip>
+
+        <SpaceShip>
+      <name>Player9</name>
+      <model>models/ships/warcruiser.obj</model>
+      <abs-coor>321.19, 200.36, 39.74</abs-coor>
+    </SpaceShip>
+
+    <SpaceShip>
+      <name>Player10</name>
+      <model>models/ships/powerdrifter.obj</model>
+      <abs-coor>321.19, 200.36, 28.74</abs-coor>
+      <abs-dir>1.5,0,1,0</abs-dir>
+    </SpaceShip>
+
+
+    <SpaceShip>
+      <name>Player11</name>
+      <model>models/ships/gobblin.obj</model>
+      <abs-coor>301.53, 210.09, 5.04</abs-coor>
+    </SpaceShip>
+
+        <SpaceShip>
+      <name>Player12</name>
+      <model>models/ships/fighter.obj</model>
+      <abs-coor>301.53, 210.09, 33.04</abs-coor>
+    </SpaceShip>
+
+    <Hover>
+      <name>Player13</name>
+      <abs-coor>301.53, 210.09, 70.04</abs-coor>
+    </Hover>
+
+
+            <SpaceShip>
+      <name>Player14</name>
+      <model>models/ships/reap_#.obj</model>
+      <abs-coor>332.19, 190.36, 34.74</abs-coor>
+    </SpaceShip>
+
+    <SpaceShip>
+      <name>Player15</name>
+      <model>models/ships/mantawing.obj</model>
+      <abs-coor>328.53, 190.09, 17.04</abs-coor>
+    </SpaceShip>
+
+        <SpaceShip>
+      <name>Player16</name>
+      <model>models/ships/warcruiser.obj</model>
+      <abs-coor>321.19, 190.36, 39.74</abs-coor>
+    </SpaceShip>
+
+    <SpaceShip>
+      <name>Player17</name>
+      <model>models/ships/powerdrifter.obj</model>
+      <abs-coor>321.19, 190.36, 28.74</abs-coor>
+      <abs-dir>1.5,0,1,0</abs-dir>
+    </SpaceShip>
+
+
+    <SpaceShip>
+      <name>Player18</name>
+      <model>models/ships/gobblin.obj</model>
+      <abs-coor>301.53, 190.09, 5.04</abs-coor>
+    </SpaceShip>
+
+        <SpaceShip>
+      <name>Player19</name>
+      <model>models/ships/fighter.obj</model>
+      <abs-coor>301.53, 190.09, 33.04</abs-coor>
+    </SpaceShip>
+
+<SkyBox>
+     <name>Sky</name>
+     <Materialset>pictures/sky/simple_space</Materialset>
+     <Size>10000</Size>
+    </SkyBox>
+
+
+    <Terrain>
+      <name>Meteroit</name>
+      <abs-coor>300,50,0</abs-coor>
+      <model>models/environments/meteorit.obj, 2.5</model>
+    </Terrain>
+
+    <MovieEntity>
+      <abs-coor>410, 185.4, 36.99</abs-coor>
+      <name>media/crash.mpg</name>
+      <axis>90</axis>
+      <size>72,40.5</size>
+    </MovieEntity>
+
+  </WorldEntities>
+    <LightManager>
+    <Lights>
+      <Light>
+       <diffuse-color>1,1,1</diffuse-color>
+       <abs-coor>100,100,50</abs-coor>
+      </Light>
+    <Light>
+       <diffuse-color>1,1,1</diffuse-color>
+       <abs-coor>100,200,50</abs-coor>
+      </Light>
+      <ambient-color>1,1,1</ambient-color>
+    </Lights>
+  </LightManager>
+
+  <GraphicsEngine>
+    <GraphicsEffect>
+        <LenseFlare>
+          <name>lense flare</name>
+          <add-flare-texture>pictures/lense_flare/sun.png</add-flare-texture>
+          <add-flare-texture>pictures/lense_flare/lens2.png</add-flare-texture>
+          <add-flare-texture>pictures/lense_flare/lens1.png</add-flare-texture>
+          <add-flare-texture>pictures/lense_flare/lens3.png</add-flare-texture>
+          <add-flare-texture>pictures/lense_flare/lens4.png</add-flare-texture>
+          <add-flare-texture>pictures/lense_flare/lens1.png</add-flare-texture>
+          <add-flare-texture>pictures/lense_flare/lens3.png</add-flare-texture>
+        </LenseFlare>
+    </GraphicsEffect>
+  </GraphicsEngine>
+
+</WorldDataFile>
Index: data/branches/avi_play/worlds/vulcania.oxw
===================================================================
--- data/branches/avi_play/worlds/vulcania.oxw	(revision 3643)
+++ data/branches/avi_play/worlds/vulcania.oxw	(revision 3648)
@@ -41,5 +41,4 @@
           <emission-velocity>700,400</emission-velocity>
           <rate>20</rate>
-          <type>cube</type>
           <size>40</size>;
           <rel-dir>1.51, 0,0,1</rel-dir>